/* 
	Trains.js
	- all functions for the trains page
*/

/* Variables  list */
var stationList = null;
/* End Variables  list */

$(document).on('pageinit', '#trainsPage', function() {
	$.mobile.loading('show');
    $.ajax({  
        url: apiUrl+"/1/train_stations",
        dataType: "jsonp",  
        success: function(data) { showStationList(data) }  
    });
});


function showStationList(data) {
	$.mobile.loading('hide');
	var output = "";	

	stationList = data.response;
	
	var popupSelector = 'popupTrainStation';
	
    for (var i in stationList) { 		//need to use lowercase station identifier
        output+="<li onclick=grabStationInfo(\""+stationList[i].identifier+"\",'"+popupSelector+"')>" + stationList[i].name + "</li>";
    }
	
    $("#ulList").html(output); 			//or .append()
	$("#ulList").trigger('create');   	//create the JQM Objects 
	$("#ulList").listview('refresh');
}


function grabStationInfo(station,popupId)
{
	$.mobile.loading('show');
	$.ajax({  
        url: apiUrl+"/1/train_stations/"+station,
        dataType: "jsonp",  
        success: function(data) { showStationPopup(data,popupId) }  
    }); 
}


function showStationPopup(data,popupId)
{
	$.mobile.loading('hide');
	
	var stationInfo = data.response;
	
	var htmlString = "<a href=\"#\" data-rel=\"back\" data-role=\"button\" data-theme=\"a\" data-icon=\"delete\" data-iconpos=\"notext\" class=\"ui-btn-right\">Close</a>"
	htmlString+="<p>"+stationInfo.name+" Station Trains</p>";
    
	htmlString+= "<div data-role=\"collapsible-set\" id=\"collapsibleSet\">"; //collapsible

	//data-mini="true"
    sortedStationInfo = $(stationInfo.times).sort(sortLine);
    
	for (var i in stationInfo.times) {
		var t = sortedStationInfo[i];
		
		htmlString+="<div data-role=\"collapsible\">"
		htmlString+="<h3>"+getStrColorHTML(t.status,t.on_time,t.time)+" <font color=black>To</font> "+getLineColorHTML(t.line)+"</h3>";
		
                if (t.pattern == null)
                {
                    htmlString+="<b>All stops</b> from Platform "+t.platform+"<br>";
                } else {
                    htmlString+="<b>"+t.pattern+"</b> Pattern from Platform "+t.platform+"<br>";
                }
				htmlString+="Destination: "+t.line+"<br>";
				htmlString+="Scheduled: <font color=\"blue\">"+t.time+"</font><br>";
                htmlString+="<b>"+getStrColorHTML(t.status,t.on_time,t.status)+"</b><br>";
				htmlString+=t.cars+" Car Train";
        
		htmlString+="</div>"; //end collapsible
	}
	htmlString+="</div>"; //end parent collapsible
	
    $('#'+popupId).html(htmlString);
	$('#'+popupId).trigger('create'); 
	$('#collapsibleSet').find('div[data-role=collapsible]').collapsible({refresh:true}); //collapsible
	$('#'+popupId).popup("open");
}


function sortLine(a,b){
	if(a.line == b.line){
		if(a.line == b.line){
			return 0;
		}
		return (a.line < b.line) ? -1 : 1;
	}
	return (a.line < b.line) ? -1 : 1;
}

function getStrColorHTML(str,on_time,str2) //works for any time or status!
{
	var color = 'green';
	if (!on_time)
	{
		var minDelay = parseInt(str);
		if (minDelay > 4)
		{
			color = 'red';
		} else {
			color = 'orange';
		}
	}

	return "<font color="+color+">"+str2+"</font>";
}

function getLineColorHTML(line)
{
	color = "#006600"; //default color (dark green)
	
    if (line == 'Midland')
        color = '#BF1B67';
    if (line == 'Armadale')
        color = '#FFC700';
    if (line == 'Thornlie')
        color = '#FFC700';
    if (line == 'Fremantle')
        color = '#006FAC';
    if (line == 'Joondalup' || line == 'Clarkson')
        color = '#B7B60E';
    if (line == 'Mandurah' || line == 'Cockburn Central')
        color = '#EE8219';
    
    return "<font color="+color+">"+line+"</font>";
}
